; -----------------------------------------------------------------------------
; #############################################################################
; -----------------------------------------------------------------------------
; Name:               MessageCC
; -----------------------------------------------------------------------------
; Prefix:             mcc_
; Version:            0.05
; Date:               2008-04-09
; Author:             David Hilberath
; Copyright:          2008 Heise Zeitschriften Verlag GmbH & Co. KG
; -----------------------------------------------------------------------------

; -----------------------------------------------------------------------------
; === Initialisation ==========================================================
; -----------------------------------------------------------------------------

init_MessageCC:
   Prefix = mcc
   %Prefix%_ScriptName    = MessageCC
   %Prefix%_ScriptVersion = 0.05
   %Prefix%_Author        = David Hilberath

   CustomHotkey_MessageCC = 0
   Hotkey_MessageCC       =
   HotkeyPrefix_MessageCC =

   WM_COMMAND           = 0x0111

   mcc_ProfileDirectory = %SettingsDir%\MessageCC
   IfNotExist, %mcc_ProfileDirectory%
      FileCreateDir, %mcc_ProfileDirectory%

   ; Sprachabhngige Variablen
   If Lng = 07  ; = Deutsch (0407, 0807, 0c07 ...)
   {
      MenuName                      = %mcc_ScriptName% - Kontrolliert Anwendungen ber Postmessages
      Description                   = Windows Postmessages erlauben das Steuern von Programmen, ohne sie aktivieren zu mssen.

      lng_mcc_profiles              = Profile
   }
   else        ; = Alternativ-Sprache (wenn nicht Deutsch und keine language.ini vorhanden)
   {
      MenuName                      = %mcc_ScriptName% - Controls applications using windows post messages
      Description                   = Windows don't have to be active to be controlled when using postmessages.
      lng_mcc_profiles              = Profiles
   }

   Gosub, LoadSettings_MessageCC
Return


LoadSettings_MessageCC:
   IniRead, mcc_activeProfiles, %ConfigFile%, %mcc_ScriptName%, ActiveProfiles, %A_Space%
   Gosub, mcc_getAllProfiles
Return


SaveSettings_MessageCC:
   ; Syntax: HotkeyWrite ( Name des Tastaturkrzels, INI-Datei, Sektion, INI-Variable [, Subroutine des Tastaturkrzels] )
   ; func_HotkeyWrite( "mcc_HOTKEYNAME", ConfigFile , mcc_ScriptName, "INI-Variable" )
   ; IniWrite, %mcc_VARIABLE%, %ConfigFile%, INI-Sektion, INI-Variable
   IniWrite, %mcc_activeProfiles%, %ConfigFile%, %mcc_ScriptName%, ActiveProfiles
Return

AddSettings_MessageCC:
Return

CancelSettings_MessageCC:
Return

DoEnable_MessageCC:
   ; func_HotkeyEnable("mcc_HOTKEYNAME")
   gosub, mcc_registerActiveProfiles
Return

DoDisable_MessageCC:
   ; func_HotkeyDisable("mcc_HOTKEYNAME")
   gosub, mcc_unRegisterActiveProfiles
Return

DefaultSettings_MessageCC:
Return

OnExitAndReload_MessageCC:
Return

; -----------------------------------------------------------------------------
; === Settings Gui ============================================================
; -----------------------------------------------------------------------------
SettingsGui_MessageCC:
   ; func_HotkeyAddGuiControl( lng_mcc_TEXT, "mcc_HOTKEYNAME", "xs+10 y+10 w160" )
   ; Gui, Add, Edit, xs+10 y+5 gsub_CheckIfSettingsChanged vmcc_var, %lng_mcc_text%
   Gui, Add, Text, XS+240 YS+13, %lng_installed% %lng_mcc_profiles%:
   Gui, Add, ListBox, -0x1000 Multi h200 w200 vmcc_activeProfilesBox gmcc_sub_ActiveSelect, %mcc_activeProfiles%
   Gui, Add, Text, XS+10 YS+13, %lng_available% %lng_mcc_profiles%:
   Gui, Add, ListBox, -0x1000 Multi h200 w200 vmcc_offProfilesBox gmcc_sub_OffSelect, %mcc_offProfiles%
   Gui, Add, Text, XS+10 Y+3  w530 -Wrap vmcc_ProfileNameText ReadOnly,

   Gui, Add, Button, -Wrap XS+213 YS+70 gmcc_sub_AllProAdd, >>
   Gui, Add, Button, -Wrap XS+216 Y+5 gmcc_sub_ProAdd, >
   Gui, Add, Button, -Wrap Y+5 gmcc_sub_ProRem, <
   Gui, Add, Button, -Wrap XS+213 Y+5 gmcc_sub_AllProRem, <<
Return

mcc_sub_ActiveSelect:
   ;PostMessage, 0x185, 0, -1, ListBox3 ; LB_SETSEL, Selektion aufheben

   GuiControlGet, mcc_ActiveSelection, , mcc_activeProfilesBox
   If mcc_ActiveSelection =
   {
      GuiControl,, mcc_ProfileNameText,
      Return
   }

   mcc_ActiveSelected =
   Loop, Parse, mcc_ActiveSelection, |
   {
      IfNotInString, mcc_LastActiveSelection, |%A_LoopField%|
         mcc_ActiveSelected = %A_LoopField%
   }

   If mcc_ActiveSelected =
   {
      IfInString, mcc_ActiveSelection, |
      {
         Loop, Parse, mcc_ActiveSelection, |
            StringReplace, mcc_LastActiveSelection, mcc_LastActiveSelection, |%A_LoopField%|, |
         StringReplace, mcc_ActiveSelected, mcc_LastActiveSelection, |,,A
      }
      Else
         mcc_ActiveSelected = %mcc_ActiveSelection%
   }
   mcc_LastActiveSelection = |%mcc_ActiveSelection%|

   GuiControl,, mcc_ProfileNameText, % mcc_ProfileNames[%mcc_ActiveSelected%]
Return

mcc_sub_OffSelect:
   ;PostMessage, 0x185, 0, -1, ListBox2 ; LB_SETSEL, Selektion aufheben

   GuiControlGet, mcc_OffSelection, , mcc_offProfilesBox
   If mcc_OffSelection =
   {
      GuiControl,, mcc_ProfileNameText,
      Return
   }
   mcc_OffSelected =
   Loop, Parse, mcc_OffSelection, |
   {
      IfNotInString, mcc_LastOffSelection, |%A_LoopField%|
         mcc_OffSelected = %A_LoopField%
   }
   If mcc_OffSelected =
   {
      IfInString, mcc_OffSelection, |
      {
         Loop, Parse, mcc_OffSelection, |
            StringReplace, mcc_LastOffSelection, mcc_LastOffSelection, |%A_LoopField%|, |
         StringReplace, mcc_OffSelected, mcc_LastOffSelection, |,,A
      }
      Else
         mcc_OffSelected = %mcc_OffSelection%
   }
   mcc_LastOffSelection = |%mcc_OffSelection%|

   GuiControl,, mcc_ProfileNameText, % mcc_ProfileNames[%mcc_OffSelected%]
return

mcc_sub_AllProAdd:
   mcc_activeProfiles = %mcc_activeProfiles%|%mcc_offProfiles%
   mcc_offProfiles =
   Sort, mcc_activeProfiles, D|
   StringLeft, mcc_PipeFirst, mcc_activeProfiles, 1
   If mcc_PipeFirst = |
      StringTrimLeft, mcc_activeProfiles, mcc_activeProfiles, 1
   GuiControl,,mcc_activeProfilesBox, |%mcc_activeProfiles%
   GuiControl,,mcc_offProfilesBox, |%mcc_offProfiles%
   func_SettingsChanged( "MessageCC" )
return

mcc_sub_ProAdd:
   GuiControlGet, mcc_OffSelection, , mcc_offProfilesBox
   Loop, Parse, mcc_OffSelection, |
   {
      mcc_OffSelected = %A_LoopField%
      If mcc_OffSelected <>
         gosub, mcc_sub_ProAdd_PartTwo
   }
return

mcc_sub_ProAdd_PartTwo:
   GuiControlGet,mcc_offProfilesBoxHwnd, Hwnd, mcc_offProfilesBox
   GetScrollInfo(mcc_offProfilesBoxHwnd, 1, mcc_offProfilesBoxPos, mcc_offProfilesBoxPage, mcc_offProfilesBoxMin, mcc_offProfilesBoxMax, mcc_offProfilesBoxTrackPos)    ; Gets scroll bar position and things

   If mcc_activeProfiles =
      mcc_activeProfiles = %mcc_OffSelected%|
   Else
      mcc_activeProfiles = %mcc_OffSelected%|%mcc_activeProfiles%
   Sort, mcc_activeProfiles, D|
   StringReplace, mcc_activeProfiles, mcc_activeProfiles, ||, |, A
   StringReplace, mcc_activeProfiles, mcc_activeProfiles, %mcc_OffSelected%|, %mcc_OffSelected%||, A
   GuiControl,,mcc_activeProfilesBox, |%mcc_activeProfiles%
   StringReplace, mcc_activeProfiles, mcc_activeProfiles, ||, |, A
   mcc_offProfiles := RegExReplace(mcc_offProfiles, mcc_OffSelected "\|([^|]*\||$)", "$1|")
   StringLeft, mcc_PipeFirst, mcc_offProfiles, 1
   If mcc_PipeFirst = |
      StringTrimLeft, mcc_offProfiles, mcc_offProfiles, 1
   GuiControl,,mcc_offProfilesBox, |%mcc_offProfiles%
   StringReplace, mcc_offProfiles, mcc_offProfiles, ||, |, A
   SetScrollPos(mcc_offProfilesBoxHwnd, 1, mcc_offProfilesBoxPos)    ; Sets scroll bar position and things
   func_SettingsChanged( "MessageCC" )
return

mcc_sub_ProRem_PartTwo:
   GuiControlGet,mcc_activeProfilesBoxHwnd, Hwnd, mcc_activeProfilesBox
   GetScrollInfo(mcc_activeProfilesBoxHwnd, 1, mcc_activeProfilesBoxPos, mcc_activeProfilesBoxPage, mcc_activeProfilesBoxMin, mcc_activeProfilesBoxMax, mcc_activeProfilesBoxTrackPos)    ; Gets scroll bar position and things

   If mcc_offProfiles =
      mcc_offProfiles = %mcc_OffSelected%|
   Else
      mcc_offProfiles = %mcc_OffSelected%|%mcc_offProfiles%
   Sort, mcc_offProfiles, D|
   StringReplace, mcc_offProfiles, mcc_offProfiles, ||, |, A
   StringReplace, mcc_offProfiles, mcc_offProfiles, %mcc_OffSelected%|, %mcc_OffSelected%||, A
   GuiControl,,mcc_offProfilesBox, |%mcc_offProfiles%
   StringReplace, mcc_offProfiles, mcc_offProfiles, ||, |, A
   mcc_activeProfiles := RegExReplace(mcc_activeProfiles, mcc_OffSelected "\|([^|]*\||$)", "$1|")
   StringLeft, mcc_PipeFirst, mcc_activeProfiles, 1
   If mcc_PipeFirst = |
      StringTrimLeft, mcc_activeProfiles, mcc_activeProfiles, 1
   GuiControl,,mcc_activeProfilesBox, |%mcc_activeProfiles%
   StringReplace, mcc_activeProfiles, mcc_activeProfiles, ||, |, A

   SetScrollPos(mcc_activeProfilesBoxHwnd, 1, mcc_activeProfilesBoxPos)    ; Sets scroll bar position and things
   func_SettingsChanged( "MessageCC" )
return

mcc_sub_ProRem:
   GuiControlGet, mcc_ActiveSelection, , mcc_activeProfilesBox
   Loop, Parse, mcc_ActiveSelection, |
   {
      mcc_ActiveSelected = %A_LoopField%
      If mcc_ActiveSelected <>
         gosub, mcc_sub_ProRem_PartTwo
   }
return

mcc_sub_AllProRem:
   mcc_offProfiles = %mcc_offProfiles%|%mcc_activeProfiles%
   mcc_activeProfiles =
   Sort, mcc_offProfiles, D|
   StringLeft, EMfirst, mcc_offProfiles, 1
   If EMfirst = |
      StringTrimLeft, mcc_offProfiles, mcc_offProfiles, 1
   GuiControl,,mcc_activeProfilesBox, |%mcc_activeProfiles%
   GuiControl,,mcc_offProfilesBox, |%mcc_offProfiles%
   func_SettingsChanged( "MessageCC" )
return


; -----------------------------------------------------------------------------
; === Hotkeys =================================================================
; -----------------------------------------------------------------------------

; Unterroutine fr das automatische Tastaturkrzel
sub_Hotkey_MessageCC:
   ; Hier kommen die Befehle hin, welche bei Win+F5 ausgefhrt werden
Return

; -----------------------------------------------------------------------------
; === Subroutines =============================================================
; -----------------------------------------------------------------------------
mcc_getAllProfiles:
   GuiDefault("activAid")

   mcc_AllProfiles =
   Loop, %mcc_ProfileDirectory%\*.ini,0,0
   {
      StringReplace, mcc_foundProfile, A_LoopFileName, .ini,

      mcc_AllProfiles = %mcc_AllProfiles%%mcc_foundProfile%|

      mcc_readProfile(mcc_foundProfile)
   }

   mcc_offProfiles := mcc_AllProfiles
   Loop, parse, mcc_activeProfiles, |
   {
      if A_LoopField =
         continue

      StringReplace, mcc_offProfiles, mcc_offProfiles, %A_LoopField%|,,All
   }
return

mcc_readProfile(mcc_profileToRead)
{
   Global
   local name, short, id, cnt,wParam,action,desc

   mcc_profileFile = %mcc_ProfileDirectory%\%mcc_profileToRead%.ini

   IniRead, name, %mcc_profileFile%, General, ApplicationName, %A_Space%
   IniRead, short,%mcc_profileFile%, General, ShortName, %A_Space%
   IniRead, id,   %mcc_profileFile%, General, Identifier, %A_Space%
   IniRead, cnt,  %mcc_profileFile%, General, ActionCount, 0

   If (name = "" || short = "" || id = "" || cnt < 1)
      return 0

   mcc_ProfileNames[%mcc_profileToRead%] := name
   mcc_ProfileShortNames[%mcc_profileToRead%] := short
   mcc_ProfileIDs[%mcc_profileToRead%] := id
   mcc_ProfileCounts[%mcc_profileToRead%] := cnt

   Loop, %cnt%
   {
      IniRead, action, %mcc_profileFile%, ActionNames, Action%A_Index%, %A_Space%
      IniRead, wParam, %mcc_profileFile%, wParam, %action%, %A_Space%

      If (action !="" AND wParam !="")
      {
         IniRead, desc, %mcc_profileFile%, Language%Lng%, %action%, %A_Space%
         if desc =
            IniRead, desc, %mcc_profileFile%, Language, %action%, %A_Space%

         mcc_ProfileActions_name[%mcc_profileToRead%][%A_Index%] := action
         mcc_ProfileActions_wParam[%mcc_profileToRead%][%A_Index%] := wParam
         mcc_ProfileActions_desc[%mcc_profileToRead%][%A_Index%] := desc
      }
   }
}

mcc_postMessage:
   StringSplit, mcc_split, ActionPara%LastAction%, |

   IfWinExist, %mcc_split2%
      PostMessage, WM_COMMAND, mcc_split1,0,
return

mcc_registerActiveProfiles:
   Loop, parse, mcc_activeProfiles, |
   {
      if A_LoopField =
         continue
      mcc_regPro := A_LoopField
      mcc_regName := mcc_ProfileNames[%A_LoopField%]
      mcc_regShort := mcc_ProfileShortNames[%A_LoopField%]
      mcc_regID := mcc_ProfileIDs[%A_LoopField%]
      mcc_regCnt := mcc_ProfileCounts[%A_LoopField%]

      Loop, %mcc_regCnt%
      {
         mcc_regAction := mcc_ProfileActions_name[%mcc_regPro%][%A_Index%]
         mcc_regwParam := mcc_ProfileActions_wParam[%mcc_regPro%][%A_Index%]
         mcc_regdesc := mcc_ProfileActions_desc[%mcc_regPro%][%A_Index%]

         RegisterAction(mcc_regAction,mcc_regShort . ": " . mcc_regdesc,"mcc_postMessage",mcc_regwParam . "|" . mcc_regID)
         ;msgbox, (%mcc_regAction%,%mcc_regShort%: %mcc_regdesc%,"mcc_postMessage",%mcc_regwParam%|%mcc_regID%)
      }
   }
return

mcc_unRegisterActiveProfiles:
   Loop, parse, mcc_activeProfiles, |
   {
      if A_LoopField =
         continue

      mcc_regPro := A_LoopField
      mcc_regCnt := mcc_ProfileCounts[%A_LoopField%]

      Loop, %mcc_regCnt%
      {
         mcc_regAction := mcc_ProfileActions_name[%mcc_regPro%][%A_Index%]
         unRegisterAction(mcc_regAction)
      }
   }
return


